"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Injector = exports.Service = void 0;
require("reflect-metadata");
exports.Service = () => {
    return (target) => {
        // do something if needed
    };
};
class Injector extends Map {
    resolve(target) {
        const tokens = Reflect.getMetadata('design:paramtypes', target) || [];
        const injections = tokens.map((token) => this.resolve(token));
        const classInstance = this.get(target);
        console.log(tokens, injections);
        if (classInstance) {
            return classInstance;
        }
        const newClassInstance = new target(...injections);
        this.set(target, newClassInstance);
        console.log(`DI-Container created class ${newClassInstance.constructor.name}`);
        return newClassInstance;
    }
}
exports.Injector = Injector;
let ServiceA = class ServiceA {
    constructor() {
        this.sum = 0;
    }
    add(value) {
        this.sum += value;
    }
};
ServiceA = __decorate([
    exports.Service()
], ServiceA);
let ServiceB = class ServiceB {
    constructor(serviceA) {
        this.serviceA = serviceA;
        this.serviceA.add(2);
    }
    test() {
        this.serviceA.add(4);
    }
};
ServiceB = __decorate([
    exports.Service(),
    __metadata("design:paramtypes", [ServiceA])
], ServiceB);
let Controller = class Controller {
    constructor(serviceA, serviceB) {
        this.serviceA = serviceA;
        this.serviceB = serviceB;
        console.log(this.serviceA.sum);
        this.serviceB.test();
        console.log(this.serviceA.sum);
    }
};
Controller = __decorate([
    exports.Service(),
    __metadata("design:paramtypes", [ServiceA, ServiceB])
], Controller);
const injector = new Injector();
// bootstrap all dependencies
const sa = injector.resolve(ServiceA);
const sb = injector.resolve(ServiceB);
const ct = injector.resolve(Controller);
console.log(sa);
console.log(sb);
console.log(ct);
//# sourceMappingURL=di.js.map